wxWidgets: wxUpdateUIEvent Class Reference

| Version: 3.1.5

Loading...
Searching...
No Matches
Public Member Functions | Static Public Member Functions | List of all members
wxUpdateUIEvent Class Reference
Class List by Category » Events

`#include </cygdrive/c/Users/Hamis/Cygwin-packaging/wxWidgets3.1/wxWidgets3.1-3.1.5-4.x86_64/src/wxWidgets-3.1.5/interface/wx/event.h>`

Inheritance diagram for wxUpdateUIEvent:
[legend]

## Detailed Description

This class is used for pseudo-events which are called by wxWidgets to give an application the chance to update various user interface elements.

Without update UI events, an application has to work hard to check/uncheck, enable/disable, show/hide, and set the text for elements such as menu items and toolbar buttons. The code for doing this has to be mixed up with the code that is invoked when an action is invoked for a menu item or button.

With update UI events, you define an event handler to look at the state of the application and change UI elements accordingly. wxWidgets will call your member functions in idle time, so you don't have to worry where to call this code.

In addition to being a clearer and more declarative method, it also means you don't have to worry whether you're updating a toolbar or menubar identifier. The same handler can update a menu item and toolbar button, if the identifier is the same. Instead of directly manipulating the menu or button, you call functions in the event object, such as wxUpdateUIEvent::Check. wxWidgets will determine whether such a call has been made, and which UI element to update.

These events will work for popup menus as well as menubars. Just before a menu is popped up, wxMenu::UpdateUI is called to process any UI events for the window that owns the menu.

If you find that the overhead of UI update processing is affecting your application, you can do one or both of the following:

- Call wxUpdateUIEvent::SetMode with a value of wxUPDATE_UI_PROCESS_SPECIFIED, and set the extra style wxWS_EX_PROCESS_UI_UPDATES for every window that should receive update events. No other windows will receive update events.
- Call wxUpdateUIEvent::SetUpdateInterval with a millisecond value to set the delay between updates. You may need to call wxWindow::UpdateWindowUI at critical points, for example when a dialog is about to be shown, in case the user sees a slight delay before windows are updated.

Note that although events are sent in idle time, defining a wxIdleEvent handler for a window does not affect this because the events are sent from wxWindow::OnInternalIdle which is always called in idle time.

wxWidgets tries to optimize update events on some platforms. On Windows and GTK+, events for menubar items are only sent when the menu is about to be shown, and not in idle time.

## Events using this class

The following event handler macros redirect the events to member function handlers 'func' with prototypes like:

void handlerFuncName(wxUpdateUIEvent& event)

Event macros:

- EVT_UPDATE_UI(id, func):
  Process a `wxEVT_UPDATE_UI` event for the command with the given id.
- EVT_UPDATE_UI_RANGE(id1, id2, func):
  Process a `wxEVT_UPDATE_UI` event for any command with id included in the given range.

  ##

Library: wxCore

<>< =''>:</>&;&;< =''>\ </></>

See also
  Events and Event Handling

## Public Member Functions
| wxUpdateUIEvent (wxWindowID commandId=0)
| Constructor.
void | Check (bool check)
| Check or uncheck the UI element.
void | Enable (bool enable)
| Enable or disable the UI element.
bool | GetChecked () const
| Returns true if the UI element should be checked.
bool | GetEnabled () const
| Returns true if the UI element should be enabled.
bool | IsCheckable () const
| Returns true if the UI element can be checked.
bool | GetSetChecked () const
| Returns true if the application has called Check().
bool | GetSetEnabled () const
| Returns true if the application has called Enable().
bool | GetSetShown () const
| Returns true if the application has called Show().
bool | GetSetText () const
| Returns true if the application has called SetText().
bool | GetShown () const
| Returns true if the UI element should be shown.
wxString | GetText () const
| Returns the text that should be set for the UI element.
void | SetText (const wxString &text)
| Sets the text for this UI element.
void | Show (bool show)
| Show or hide the UI element.
Public Member Functions inherited from wxCommandEvent
| wxCommandEvent (wxEventType commandEventType=wxEVT_NULL, int id=0)
| Constructor.
void * | GetClientData () const
| Returns client data pointer for a listbox or choice selection event (not valid for a deselection).
wxClientData * | GetClientObject () const
| Returns client object pointer for a listbox or choice selection event (not valid for a deselection).
long | GetExtraLong () const
| Returns extra information dependent on the event objects type.
int | GetInt () const
| Returns the integer identifier corresponding to a listbox, choice or radiobox selection (only if the event was a selection, not a deselection), or a boolean value representing the value of a checkbox.
int | GetSelection () const
| Returns item index for a listbox or choice selection event (not valid for a deselection).
wxString | GetString () const
| Returns item string for a listbox or choice selection event.
bool | IsChecked () const
| This method can be used with checkbox and menu events: for the checkboxes, the method returns true for a selection event and false for a deselection one.
bool | IsSelection () const
| For a listbox or similar event, returns true if it is a selection, false if it is a deselection.
void | SetClientData (void *clientData)
| Sets the client data for this event.
void | SetClientObject (wxClientData *clientObject)
| Sets the client object for this event.
void | SetExtraLong (long extraLong)
| Sets the m_extraLong member.
void | SetInt (int intCommand)
| Sets the m_commandInt member.
void | SetString (const wxString &string)
| Sets the m_commandString member.
Public Member Functions inherited from wxEvent
| wxEvent (int id=0, wxEventType eventType=wxEVT_NULL)
| Constructor.
virtual wxEvent * | Clone () const =0
| Returns a copy of the event.
wxObject * | GetEventObject () const
| Returns the object (usually a window) associated with the event, if any.
wxEventType | GetEventType () const
| Returns the identifier of the given event type, such as `wxEVT_BUTTON`.
virtual wxEventCategory | GetEventCategory () const
| Returns a generic category for this event.
int | GetId () const
| Returns the identifier associated with this event, such as a button command id.
wxObject * | GetEventUserData () const
| Return the user data associated with a dynamically connected event handler.
bool | GetSkipped () const
| Returns true if the event handler should be skipped, false otherwise.
long | GetTimestamp () const
| Gets the timestamp for the event.
bool | IsCommandEvent () const
| Returns true if the event is or is derived from wxCommandEvent else it returns false.
void | ResumePropagation (int propagationLevel)
| Sets the propagation level to the given value (for example returned from an earlier call to wxEvent::StopPropagation).
void | SetEventObject (wxObject *object)
| Sets the originating object.
void | SetEventType (wxEventType type)
| Sets the event type.
void | SetId (int id)
| Sets the identifier associated with this event, such as a button command id.
void | SetTimestamp (long timeStamp=0)
| Sets the timestamp for the event.
bool | ShouldPropagate () const
| Test if this event should be propagated or not, i.e. if the propagation level is currently greater than 0.
void | Skip (bool skip=true)
| This method can be used inside an event handler to control whether further event handlers bound to this event will be called after the current one returns.
int | StopPropagation ()
| Stop the event from propagating to its parent window.
Public Member Functions inherited from wxObject
| wxObject ()
| Default ctor; initializes to NULL the internal reference data.
| wxObject (const wxObject &other)
| Copy ctor.
virtual | ~wxObject ()
| Destructor.
virtual wxClassInfo * | GetClassInfo () const
| This virtual function is redefined for every class that requires run-time type information, when using the wxDECLARE_CLASS macro (or similar).
wxObjectRefData * | GetRefData () const
| Returns the wxObject::m_refData pointer, i.e. the data referenced by this object.
bool | IsKindOf (const wxClassInfo *info) const
| Determines whether this class is a subclass of (or the same class as) the given class.
bool | IsSameAs (const wxObject &obj) const
| Returns true if this object has the same data pointer as obj.
void | Ref (const wxObject &clone)
| Makes this object refer to the data in clone.
void | SetRefData (wxObjectRefData *data)
| Sets the wxObject::m_refData pointer.
void | UnRef ()
| Decrements the reference count in the associated data, and if it is zero, deletes the data.
void | UnShare ()
| This is the same of AllocExclusive() but this method is public.
void | operator delete (void *buf)
| The delete operator is defined for debugging versions of the library only, when the identifier `__WXDEBUG__` is defined.
void * | operator new (size_t size, const wxString &filename=NULL, int lineNum=0)
| The new operator is defined for debugging versions of the library only, when the identifier `__WXDEBUG__` is defined.

## Static Public Member Functions
static bool | CanUpdate (wxWindow *window)
| Returns true if it is appropriate to update (send UI update events to) this window.
static wxUpdateUIMode | GetMode ()
| Static function returning a value specifying how wxWidgets will send update events: to all windows, or only to those which specify that they will process the events.
static long | GetUpdateInterval ()
| Returns the current interval between updates in milliseconds.
static void | ResetUpdateTime ()
| Used internally to reset the last-updated time to the current time.
static void | SetMode (wxUpdateUIMode mode)
| Specify how wxWidgets will send update events: to all windows, or only to those which specify that they will process the events.
static void | SetUpdateInterval (long updateInterval)
| Sets the interval between updates in milliseconds.

## Additional Inherited Members
Protected Member Functions inherited from wxObject
void | AllocExclusive ()
| Ensure that this object's data is not shared with any other object.
virtual wxObjectRefData * | CreateRefData () const
| Creates a new instance of the wxObjectRefData-derived class specific to this object and returns it.
virtual wxObjectRefData * | CloneRefData (const wxObjectRefData *data) const
| Creates a new instance of the wxObjectRefData-derived class specific to this object and initializes it copying data.
Protected Attributes inherited from wxEvent
int | m_propagationLevel
| Indicates how many levels the event can propagate.
Protected Attributes inherited from wxObject
wxObjectRefData * | m_refData
| Pointer to an object which is the object's reference-counted data.

## Constructor & Destructor Documentation

## ◆ wxUpdateUIEvent()

wxUpdateUIEvent::wxUpdateUIEvent | ( | wxWindowID | commandId = 0 | ) |

Constructor.

## Member Function Documentation

## ◆ CanUpdate()

bool wxUpdateUIEvent::CanUpdate | ( | wxWindow * | window | ) |
| static

Returns true if it is appropriate to update (send UI update events to) this window.

This function looks at the mode used (see wxUpdateUIEvent::SetMode), the wxWS_EX_PROCESS_UI_UPDATES flag in window, the time update events were last sent in idle time, and the update interval, to determine whether events should be sent to this window now. By default this will always return true because the update mode is initially wxUPDATE_UI_PROCESS_ALL and the interval is set to 0; so update events will be sent as often as possible. You can reduce the frequency that events are sent by changing the mode and/or setting an update interval.

See also
  ResetUpdateTime(), SetUpdateInterval(), SetMode()

## ◆ Check()

void wxUpdateUIEvent::Check | ( | bool | check | ) |

Check or uncheck the UI element.

## ◆ Enable()

void wxUpdateUIEvent::Enable | ( | bool | enable | ) |

Enable or disable the UI element.

## ◆ GetChecked()

bool wxUpdateUIEvent::GetChecked | ( |  | ) | const

Returns true if the UI element should be checked.

## ◆ GetEnabled()

bool wxUpdateUIEvent::GetEnabled | ( |  | ) | const

Returns true if the UI element should be enabled.

## ◆ GetMode()

wxUpdateUIMode wxUpdateUIEvent::GetMode | ( |  | ) |
| static

Static function returning a value specifying how wxWidgets will send update events: to all windows, or only to those which specify that they will process the events.

See also
  SetMode()

## ◆ GetSetChecked()

bool wxUpdateUIEvent::GetSetChecked | ( |  | ) | const

Returns true if the application has called Check().

For wxWidgets internal use only.

## ◆ GetSetEnabled()

bool wxUpdateUIEvent::GetSetEnabled | ( |  | ) | const

Returns true if the application has called Enable().

For wxWidgets internal use only.

## ◆ GetSetShown()

bool wxUpdateUIEvent::GetSetShown | ( |  | ) | const

Returns true if the application has called Show().

For wxWidgets internal use only.

## ◆ GetSetText()

bool wxUpdateUIEvent::GetSetText | ( |  | ) | const

Returns true if the application has called SetText().

For wxWidgets internal use only.

## ◆ GetShown()

bool wxUpdateUIEvent::GetShown | ( |  | ) | const

Returns true if the UI element should be shown.

## ◆ GetText()

wxString wxUpdateUIEvent::GetText | ( |  | ) | const

Returns the text that should be set for the UI element.

## ◆ GetUpdateInterval()

long wxUpdateUIEvent::GetUpdateInterval | ( |  | ) |
| static

Returns the current interval between updates in milliseconds.

The value -1 disables updates, 0 updates as frequently as possible.

See also
  SetUpdateInterval().

## ◆ IsCheckable()

bool wxUpdateUIEvent::IsCheckable | ( |  | ) | const

Returns true if the UI element can be checked.

For the event handlers that can be used for multiple items, not all of which can be checked, this method can be useful to determine whether to call Check() on the event object or not, i.e. the main use case for this method is:

void MyWindow::OnUpdateUI(wxUpdateUIEvent& event)
{
....
if ( event.IsCheckable() )
event.Check(...some condition...);
}
wxUpdateUIEvent::IsCheckable
bool IsCheckable() const
Returns true if the UI element can be checked.
wxUpdateUIEvent::wxUpdateUIEvent
wxUpdateUIEvent(wxWindowID commandId=0)
Constructor.

Since
  3.1.5

## ◆ ResetUpdateTime()

void wxUpdateUIEvent::ResetUpdateTime | ( |  | ) |
| static

Used internally to reset the last-updated time to the current time.

It is assumed that update events are normally sent in idle time, so this is called at the end of idle processing.

See also
  CanUpdate(), SetUpdateInterval(), SetMode()

## ◆ SetMode()

void wxUpdateUIEvent::SetMode | ( | wxUpdateUIMode | mode | ) |
| static

Specify how wxWidgets will send update events: to all windows, or only to those which specify that they will process the events.

Parameters

  mode | this parameter may be one of the wxUpdateUIMode enumeration values. The default mode is wxUPDATE_UI_PROCESS_ALL.

## ◆ SetText()

void wxUpdateUIEvent::SetText | ( | const wxString & | text | ) |

Sets the text for this UI element.

## ◆ SetUpdateInterval()

void wxUpdateUIEvent::SetUpdateInterval | ( | long | updateInterval | ) |
| static

Sets the interval between updates in milliseconds.

Set to -1 to disable updates, or to 0 to update as frequently as possible. The default is 0.

Use this to reduce the overhead of UI update events if your application has a lot of windows. If you set the value to -1 or greater than 0, you may also need to call wxWindow::UpdateWindowUI at appropriate points in your application, such as when a dialog is about to be shown.

## ◆ Show()

void wxUpdateUIEvent::Show | ( | bool | show | ) |

Show or hide the UI element.